#!/bin/bash
# meta-meta script by Ed Cates
# intended to flash Sprint Pre phones with a working webOS 2.1 image
#  Your mileage may vary

SPRINT_JAR_URL="http://palm.cdnetworks.net/rom/pre/p145r0d08102010/spr1ntp145rod/webosdoctorp100ewwsprint.jar"
VZW_JAR_URL="http://palm.cdnetworks.net/rom/pre2/p201r0d02172011/ver1z0np201rod/webosdoctorp102verizonwireless.jar"
VODA_JAR_URL="http://palm.cdnetworks.net/rom/preplus/p210r0d02212011/eudep210rod/webosdoctorp101ueude-wr.jar"

SPRINT_FILE="webosdoctorp100ewwsprint-1.4.5.jar"
VZW_FILE="webosdoctorp102verizonwireless-2.0.1.jar"
VODA_FILE="webosdoctorp101ueude-wr-2.1.0.jar"

SPRINT_BUILD="pre-p100eww-sprint-1.4.5"
VZW_BUILD="pre2-p102eww-verizonwireless-2.0.1"
VODA_BUILD="preplus-p101ueude-wr-2.1.0"

WORK_DIR="webOS"
META_DIR="meta-doctor"

git="/usr/bin/git"
wget="/usr/bin/wget"
make="/usr/bin/make"
jar="/usr/bin/jar"
java="/usr/bin/java"
patch="/usr/bin/patch"

WEBOS_TARBALL="webOS.tar"
SRC_CDMA_FW="roadrunnercdma_fw.tar"
CDMA_FW="castlecdmafw.tar"
BLD_INFO="palm-build-info"


for f in $git $wget $make $jar $java $patch; do
	
	[ -x $f ] || ( echo "Cannot find $f.  Please install it." && exit )

done

[ ! -d ~/${WORK_DIR}/ ] && mkdir ~/${WORK_DIR} 

cd ~/${WORK_DIR}

$git clone git://git.webos-internals.org/tools/meta-doctor.git || exit

mkdir ${META_DIR}/downloads

cd ${META_DIR}/downloads

[ ! -f ${SPRINT_FILE} ] && $wget ${SPRINT_JAR_URL} -O ${SPRINT_FILE}
[ ! -f ${VZW_FILE} ] && $wget ${VZW_JAR_URL} -O ${VZW_FILE}
[ ! -f ${VODA_FILE} ] && $wget ${VODA_JAR_URL} -O ${VODA_FILE}

cd ~/${WORK_DIR}/${META_DIR}

$make DEVICE=pre CARRIER=sprint unpack
$make DEVICE=pre2 CARRIER=verizonwireless unpack
$make DEVICE=preplus CARRIER=wr unpack

cp build/${VODA_BUILD}/resources/webOS.tar ./

tar -C ./ -f ./build/${VZW_BUILD}/resources/webOS.tar -x ./${SRC_CDMA_FW}

tar -C ./ -f ./webOS.tar --delete ./${CDMA_FW}

mv ${SRC_CDMA_FW} ${CDMA_FW}

tar -C ./ -f ./webOS.tar --append ./${CDMA_FW}

cp build/${SPRINT_BUILD}/rootfs/etc/${BLD_INFO} ./

cp build/${VODA_BUILD}/rootfs/etc/${BLD_INFO} ./${BLD_INFO}-unmasqed

make clobber

make ENABLE_DEVELOPER_MODE=1 AUTO_INSTALL_PREWARE=1 DISABLE_UPLOAD_DAEMON=1 DISABLE_UPDATE_DAEMON=1 CUSTOM_CARRIER_CHECK="H4sIALt7FkwAA+3POw7CMBCEYdecIicItrHjA9DT5AAoglXkAoOMeRwfAyU0SBCa/2tGWk0x2843Q85R8nrVL9tyLer7dNU5d08TvK5pF87qx/0pKGNscMbbLlilje+8UY3+wZYXp2MZctOoLOcol+0gu31615M0xiSSYxqnmDWV/lA/KrN/zwAAAAAAAAAAAAAAAAAAfOgGNIYjgAAoAAA=" CUSTOM_MODEL_CHECK="H4sIALt7FkwAA+3OuwrCQBSE4a19ijxBPLubywOIrQgWKSWQQwiYDcR4eXzXlGJjkdj8XzMwTDHpth8avZwPp106PSezBImKLHunLXOJ6XzmZO5nVoy1vnSFK3Mfe5t7600ii7z5cLtO9ZgkZtR7p4+m1n4I33Ya2i6ojl1o17i1lqMV2VfV5t8/AAAAAAAAAAAAAAAAAAC/eQGGRWJfACgAAA==" CUSTOM_WEBOS_DMSET=base CUSTOM_CARRIER_DMSET=a CUSTOM_BUILD_INFO=palm-build-info CUSTOM_WEBOS_TARBALL=webOS.tar DEVICE=preplus CARRIER=wr all

$java -jar build/${VODA_BUILD/webosdoctorp101ueude-wr-2.1.0.jar
